<template>
  <div class="flex flex-col h-full">
    <PageHeader
      :loading="isLoading"
      @refresh="fetchData"
    />

    <Viewport>
      <UsersGridSkeleton v-if="isLoading" />

      <div
        v-show="usersStore.users.length"
        class="grid gap-4 lg:gap-6 grid-cols-1 md:grid-cols-2 xl:grid-cols-3"
      >
        <v-slide-y-transition
          group
          leave-absolute
        >
          <section
            v-for="user in usersStore.users"
            :key="user.id"
          >
            <UserEntity :data="user" />
          </section>
        </v-slide-y-transition>
      </div>
    </Viewport>
  </div>

  <CreateUserForm />
</template>

<script setup lang="ts">
import { ref, onMounted } from 'vue';

import PageHeader from '@/components/layout/PageHeader.vue';
import Viewport from '@/components/layout/Viewport.vue';
import UsersGridSkeleton from '@/components/skeletons/UsersGridSkeleton.vue';

import UserEntity from './UserEntity.vue';
import CreateUserForm from './CreateUserForm.vue';

import { useUsersStore } from '@/stores';

const usersStore = useUsersStore();
const isLoading = ref(false);

const fetchData = async () => {
  isLoading.value = true;
  await usersStore.fetchData();
  isLoading.value = false;
};

onMounted(fetchData);
</script>